
#ifndef __TEXTUREMANAGERINTERFACE_H_
#define __TEXTUREMANAGERINTERFACE_H_


#include <windows.h>
#include <string>

/**
* This object is used to manage and store our Textures
* for our small DLL rendering system.
* For now it doesn't really do much besides load and
* create texture objects, but the flexibility is 
* there to add more features if needed
*/
class textureManagerInterface {

public:
	/**
	* Constructor
	*/
	textureManagerInterface(){};

	/**
	* Destructor
	*/
	virtual ~textureManagerInterface(){};

	/**
	* version 1.3
	* This method is responsible for adding a new texture to our
	* rendering engine. We won't do anything that fancy but store
	* it in a std::map object
	* @param std::string - our texture filename
	* @param const int   - the texture identifier
	* @return HRESULT    - SUCCEEDED if we created it ok, FAILED otherwise
	*/
	virtual HRESULT addTexture(std::string strFilename, const int value) = 0;

	/**
	* version 1.3
	* This method is responsible for letting the renderer engine
	* know which texture we want to use
	* @param const int - the texture identifier
	* @return void
	*/
	virtual void setTexture(const int value) = 0;




};

#endif